# Introduction

Please see the main docstring in each program for details.

# Notes

The `mnist_data_distributed.py` program requires the [`slns.distribution`](
https://gitlab.version.fz-juelich.de/hpc4ns/slns_utils#1-slnsdistribution)
module for distribution of training data filenames across multiple ranks. 
Please follow the steps below to install the required package.

1.  Change to the source directory for this sample, i.e., to `dl_on_supercomputers/horovod_data_distributed` 
2.  Load the system-wide Python module.
    *  On JURECA and JUWELS: `module load Python/3.6.8`
    *  On JURON: `module load Python/3.6.1`
3.  Create a Python virtual environment: `python -m venv venv_dl_slns`
4.  Activate the virtual environment: `source activate venv_dl_slns/bin/activate`
5.  Install the `slns` package: `python -m pip install git+https://gitlab.version.fz-juelich.de/hpc4ns/slns_utils.git`
6.  Open the job submission script you intend to use, and make sure the path to the virtual environment is correct

Once all the above steps are completed, the job can be submitted.

**Note:** A maximum of eight ranks can be used to run `mnist_data_distributed.py`, as there
only eight training files.